program gpk_extract;
{written by Jrg Polzfu; 30.4.96; e-mail:pilz@cs.tu-berlin.de}
{debugged version: 24.9.96}
{NEVERTHELESS: USE IT AT YOUR OWN RISK!}
{BENUTZUNG TROTZDEM AUF EIGENE GEFAHR!}
{UTILISATION QUAND MEME A VOS RISQUES!}
var
  gpk,out: file of byte;
  i: byte;
  x,anzahl,xa: word;
  xg,titelanf,textanf,groesse,lgroesse,xlg: longint;
  datblockanf: array[0..255] of longint;
  outname: string;
  anfstr: boolean;
begin
  writeln('    GPK-Extractor for DOS 1.0 German; Public domain by Jrg Polzfu 1996');
  writeln('                       USE IT AT YOUR OWN RISK!');
  writeln('                     BENUTZUNG AUF EIGENE GEFAHR!');
  writeln('                      UTILISATION A VOS RISQUES!');
  writeln;
  if paramcount<>1 then
  begin
    writeln('USAGE/BENUTZUNG/UTILISATION: gpk_ex gpkfile.gpk');
    writeln;
    writeln('REMEMBER: THE DESTINATION-DIRECTORIES HAVE TO EXIST BEFORE RUNNING');
    writeln('          THIS PROGRAM! OTHERWISE: RUNTIME ERROR 003!');
    writeln('BEDENKE : DIE ZIELVERZEICHNISSE MSSEN VOR DEM PROGRAMMSTART EXISTIEREN!');
    writeln('          SONST: RUNTIME ERROR 003!');
    writeln('PRENEZ GARDE: LES "DESTINATION-DIRECTORIES" DOIVENT EXISTER AVANT');
    writeln('          D',chr($27),'INITIALIZER CE LOGICIEL! SI NON: RUNTIME ERROR 003!');
    writeln;
    halt(2);
  end;
  Assign(gpk,paramstr(1));
  Reset(gpk);
  anfstr:=true;
  read(gpk,i);
  if chr(ord(i))<>'G' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'E' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'O' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'S' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'_' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'G' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'P' then anfstr:=false;
  read(gpk,i);
  if chr(ord(i))<>'X' then anfstr:=false;
  if anfstr=false then begin writeln('Kein GPK-File!?'); halt(3); end;
  seek(gpk,20); {restl. "Vorspann" bergehen}
  {Dateizahl lesen (16b)}
  Read(gpk,i);
  x:=i;
  Read(gpk,i);
  x:=i*256+x;
  anzahl:=x;
  WriteLn('Anzahl der Dateien:',anzahl);
  if anzahl>255 then begin writeln('Zu viele!'); halt(1); end;
  {Titelanfang lesen (32b)}
  Read(gpk,i);
  x:=i;
  Read(gpk,i);
  x:=i*256+x;
  titelanf:=x;
  Read(gpk,i);
  x:=i;
  Read(gpk,i);
  x:=i*256+x;
  titelanf:=x*65536+titelanf;
  {WriteLn('Anfang des Titelstrings:',titelanf);}
  {Textanfang lesen (32b)}
  Read(gpk,i);
  x:=i;
  Read(gpk,i);
  x:=i*256+x;
  textanf:=x;
  Read(gpk,i);
  x:=i;
  Read(gpk,i);
  x:=i*256+x;
  textanf:=x*65536+textanf;
  {WriteLn('Anfang der Beschreibung:',textanf);}
  {Anfnge der Datenblcke lesen (je 32b)}
  for xa:=0 to anzahl-1 do
  begin
    Read(gpk,i);
    x:=i;
    Read(gpk,i);
    x:=i*256+x;
    datblockanf[xa]:=x;
    Read(gpk,i);
    x:=i;
    Read(gpk,i);
    x:=i*256+x;
    datblockanf[xa]:=x*65536+datblockanf[xa];
    {WriteLn('Anfang der ',xa+1,'. Datei:',datblockanf[xa]);}
  end;
  writeln;
  {Titel lesen und ausgeben:}
  seek(gpk,titelanf);
  repeat
    Read(gpk,i);
    Write(chr(i));
  until i=0;
  writeln;
  {Text lesen und ausgeben:}
  seek(gpk,textanf);
  repeat
    Read(gpk,i);
    Write(chr(i));
  until i=0;
  writeln;
  writeln;
  {fr alle Blcke:}
  for xa:=0 to anzahl-1 do
  begin
       seek(gpk,datblockanf[xa]);
       write('Dateiname: ');
       repeat
         Read(gpk,i);
         Write(chr(i));
       until i=0;
       writeln;
       write('Pfad+Dateiname: ');
       outname:='';
       repeat
         Read(gpk,i);
         Write(chr(i));
         if i<>0 then outname:=outname+chr(i);
       until i=0;
       writeln;
       write('Dateiversion: ');
       repeat
         Read(gpk,i);
         Write(chr(i));
       until i=0;
       writeln;
       {Gre v. Datenblock lesen (32b)}
       Read(gpk,i);
       x:=i;
       Read(gpk,i);
       x:=i*256+x;
       groesse:=x;
       Read(gpk,i);
       x:=i;
       Read(gpk,i);
       x:=i*256+x;
       groesse:=x*65536+groesse;
       WriteLn('Gre der Datei:',groesse);
       seek(gpk,filepos(gpk)+4); {ab hier Datei}{was steht in den 4 Bytes?}
         assign(out,outname);
         rewrite(out);   {scheitert, wenn Zielverzeichnis nicht existiert!}
         while groesse>0 do
         begin
           Read(gpk,i);
           x:=i;
           Read(gpk,i);
           x:=i*256+x;
           lgroesse:=x;
           Read(gpk,i);
           x:=i;
           Read(gpk,i);
           x:=i*256+x;
           lgroesse:=x*65536+lgroesse;
           for xlg:=1 to lgroesse do
           begin
             read(gpk,i);
             write(out,i);
           end;
           groesse:=groesse-lgroesse;
         end;
         close(out);
         writeln;
  end;
  Close(gpk);
end.
